##########################################################
# Image analysis to determine colocalization
# It basically estimates correlation between two channels 
# using Hfactor, pearson, overlap and Manders 
# Henry David Herce 20/7/2009
##########################################################
from Priithon.all import *
from numpy import *
#import time
#import os
import sys
import glob
#
#
def maxval (fpath,neigh=20):
# fpath = "/home/labuser/henry/files/"  path to files
### open file
 FILEmax = open(fpath+'/maxSOI.txt', "w")
### create a list with the files in the directory 
 fpath=fpath+"/*"
 dd = glob.glob(fpath)
 dd.sort()
###############################
### File number
 FILEmax.write("File Name\tZ-stack\tHfact\tPearsons\tOverlap\tMandersR\tMandersG\n") 
 for fname in dd: 
### check if it is the c01 file and take also the c02 
  if 'c01' in fname and '.tif' in fname:
###############################
### one file for each coefficient
   FILEHfac = open(fname.replace('c01','Max').replace('tif','txt') , "r")  
# from this SOI I extract the SOI number
   FILEmaxx = open(fname.replace('c01','SOI').replace('tif','txt') , "r")
   k=0  
   for line in FILEmaxx.readlines():
    if k == 1 :   
     kl = int(line.split("\t")[2]) 
    k=k+1                                                              
###############################
### loop over z frames
   kl=kl+1 
   k=0  
   for lineh in FILEHfac.readlines():   
    if k == kl : # skip the first line        
     FILEmax.write(lineh) 
    k=k+1     
   FILEHfac.close()
   k=0      
   FILEHfac.close()            
 FILEmax.close()          
#
def main():    
    #fpath = '/home/labuser/Users/Corella/data/forcolocalizationanalysis'
    fpath = '/home/labuser/Users/Corella/hen/'
    coloca(fpath)


if __name__ == '__main__':
    main()



                      
            
                      

