##########################################################
# Image analysis to extract the nucleus  
# Henry David Herce 15/10/2009
##########################################################
from Priithon.all import *
from numpy import *
#import time
#import os
import sys
#
def nucextr(fpath):
### create a list with the files in the directory
 fpath=fpath+"/*"
 import glob
 dd = glob.glob(fpath)
 dd.sort() 
###############################    
### File number
 for fname in dd: 
### check if it is the c01 file and take also the c02 
  if 'c01' in fname and '.tif' in fname:
   imzr = U.loadImg(fname)    # chromocenter file
   imzg = U.loadImg(fname.replace('c01','c02')) 
#   print imzr.dtype   
#   
   dim = imzr.shape 
   imt = zeros((dim[0],dim[1],dim[2]))  
   imtt = zeros((dim[0],dim[1],dim[2]))           
###############################
### loop over z frames
   for iim in range(0, dim[0]):
    imr = imzr[iim]
    img = imzg[iim]
###############################
# average intensity for each channel
    aver = 0
    aveg = 0    
    nr = 0
    ng = 0
    for i in range(0, dim[1]):
     for j in range(0, dim[2]):  
      if imr[i,j] > 0:
       nr=nr+1
       aver=aver+imr[i,j]
      if img[i,j] > 0:        
       ng=ng+1  
       aveg=aveg+img[i,j]    
#       
    aver=aver/nr 
    aveg=aveg/ng 
#    
    imt[iim] = imr/aver+img/aveg    
#    
    avet=0
    nt=0
    for i in range(0, dim[1]):
     for j in range(0, dim[2]):  
      if imt[iim][i,j] > 0:
       nt=nt+1
       avet=avet+imt[iim][i,j]         
    avet=avet/nt        
#    
    for i in range(0, dim[1]):
     for j in range(0, dim[2]):  
      if imt[iim][i,j] < avet:
       imt[iim][i,j]=0
#
    for i in range(5, dim[1]-5):
     for j in range(5, dim[2]-5):                   
      nt=0                   
      for ii in range(-5, 6):
       for jj in range(-5, 6):      
        if imt[iim][i+ii,j+jj]>0:
          nt=nt+1
      if nt>50:
        imtt[iim][i,j]=1000                

#
#    for i in range(0, dim[1]):
#     for j in range(0, dim[2]):            
#      if imt[iim][i,j]>0:          
#        imt[iim][i,j]=1000
#    print iim 
#    Y.refresh()        
#        
   U.saveImg(imtt.astype(N.uint16),fname.replace('c01','nuc'),forceMultipage=1)          

def main():    
    #fpath = '/home/labuser/Users/Corella/data/forcolocalizationanalysis'
    fpath = '/home/labuser/Users/Corella/hen/'
    coloca(fpath)


if __name__ == '__main__':
    main()
               
    
       
       
                   
