##########################################################
# Image analysis to determine colocalization
# It basically estimates correlation between two channels 
# using Hfactor, pearson, overlap and Manders 
# Henry David Herce 20/7/2009
##########################################################
from Priithon.all import *
from numpy import *
#import time
#import os
import sys
import glob
#
#
def maxval (fpath,neigh=20):
# fpath = "/home/labuser/henry/files/"  path to files
### create a list with the files in the directory
 fpath=fpath+"/*"
 dd = glob.glob(fpath)
 dd.sort()
###############################
### File number
 for fname in dd: 
### check if it is the c01 file and take also the c02 
  if 'c01' in fname and '.tif' in fname:
###############################
### one file for each coefficient
   FILEmax = open(fname.replace('c01','SOI').replace('tif','txt') , "w")
   FILEHfac = open(fname.replace('c01','Hfac').replace('tif','txt') , "r")
   FILEpea = open(fname.replace('c01','pea').replace('tif','txt') , "r")
   FILEover = open(fname.replace('c01','over').replace('tif','txt') , "r")   
   FILErman = open(fname.replace('c01','c01man').replace('tif','txt') , "r")
   FILEgman = open(fname.replace('c01','c02man').replace('tif','txt') , "r") 
   FILEmax.write("File Name\tCoefficient\tZ-stack") 
   for j in range(0,neigh):
    FILEmax.write("\tPixDist-%s" % j)            
   for j in range(0,neigh):
    FILEmax.write("\tPixDist-%s" % j)
   FILEmax.write('\n')                          
###############################
### loop over z frames
   diffo=0 
   k=0  
   for line in FILEHfac.readlines():   
    if k > 0 : # skip the first line
     llt = line  # save full line 
     vv = line.split("\t") # split line
     diff= abs(float(vv[4])-float(vv[23])) 
     if diff > diffo :
      diffo = diff
      ll = llt
      kl = k
    k=k+1
   k=0     
   FILEmax.write(ll) 
   FILEHfac.close()    
   for linep in FILEpea.readlines():
    if k == kl : # skip the first line        
     FILEmax.write(linep) 
    k=k+1     
   FILEpea.close() 
   k=0          
   for lineo in FILEover.readlines():
    if k == kl : # skip the first line        
     FILEmax.write(lineo) 
    k=k+1     
   FILEover.close() 
   k=0             
   for liner in FILErman.readlines():
    if k == kl : # skip the first line        
     FILEmax.write(liner) 
    k=k+1     
   FILErman.close()  
   k=0                             
   for lineg in FILEgman.readlines():
    if k == kl : # skip the first line        
     FILEmax.write(lineg)
    k=k+1     
   FILEgman.close()        
 FILEmax.close()          
#
def main():    
    #fpath = '/home/labuser/Users/Corella/data/forcolocalizationanalysis'
    fpath = '/home/labuser/Users/Corella/hen/'
    coloca(fpath)


if __name__ == '__main__':
    main()



                      
            
                      

