##########################################################
# Image analysis to determine colocalization
# It basically estimates correlation between two channels 
# using Hfactor, pearson, overlap and Manders 
# Henry David Herce 20/7/2009
##########################################################
from Priithon.all import *
from numpy import *
#import time
#import os
import sys
import glob
import os
import smtplib
#
###############################
spath = '/Users/labuser/Desktop/magic/'
fpath = '/Users/labuser/Desktop/z20100104_P_XY9_cropped1/'
bord = 25
neigh= 20
###############################
# sned email? no=0, yes=1
email = 1
###############################
# send email
def semail (title,text):
 FROMADDR = "image.analysis.cardosolab@gmail.com"
 LOGIN    = "image.analysis.cardosolab"
 PASSWORD = "epi-genome"
 TOADDRS  = ["corella.casas.delucchi@googlemail.com"]
 SUBJECT  = title

 msg = ("From: %s\r\nTo: %s\r\nSubject: %s\r\n\r\n"
        % (FROMADDR, ", ".join(TOADDRS), SUBJECT) )
 msg += text+"\r\n"

 server = smtplib.SMTP('smtp.gmail.com', 587)
 server.set_debuglevel(1)
 server.ehlo()
 server.starttls()
 server.login(LOGIN, PASSWORD)
 server.sendmail(FROMADDR, TOADDRS, msg)
 server.quit() 
###############################
folder = fpath.split("/")[-2]
if email == 1:
 semail ('Starting '+folder,'The magic has started')
import nucl_extr
nucl_extr.nucextr(fpath)
import filter_hen
filter_hen.filter_hen(fpath,bord,neigh) 
import factors
factors.factors(fpath, neigh)
import factors_max
factors_max.factors(fpath, neigh)
import SOI_values
SOI_values.maxval(fpath, neigh)
if email == 1:
 semail ('Factors for'+folder,'Factors ready')
import factor_rr
factor_rr.factors(fpath, neigh)
import rrSOI_values
rrSOI_values.maxval(fpath, neigh)
import factor_gg
factor_gg.factors(fpath, neigh)
import ggSOI_values
ggSOI_values.maxval(fpath, neigh)
import maxSOI_values
maxSOI_values.maxval(fpath, neigh)
if email == 1:
 semail ('Factors gg and rr'+folder,'Factors gg & gg ready')

###############################           



                      
            
                      

